"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SoftDeletable = void 0;
require("./soft-deletable-handler.subscriber");
const core_1 = require("@mikro-orm/core");
const soft_deletable_symbol_1 = require("./soft-deletable.symbol");
const soft_deletable_filter_constant_1 = require("./soft-deletable-filter.constant");
const soft_deletable_handler_subscriber_1 = require("./soft-deletable-handler.subscriber");
function SoftDeletable(_configOrType, _field, _value, _valueInitial) {
    const config = typeof _configOrType === "function"
        ? _field && _value
            ? {
                type: _configOrType,
                field: _field,
                value: _value,
                valueInitial: _valueInitial,
            }
            : null
        : _configOrType;
    if (!config)
        throw new Error("Invalid arguments");
    const { field, value, valueInitial } = config;
    return (type) => {
        const metadata = { field, value };
        Reflect.defineMetadata(soft_deletable_symbol_1.SOFT_DELETABLE, metadata, type);
        (0, core_1.Filter)({
            name: soft_deletable_filter_constant_1.SOFT_DELETABLE_FILTER,
            cond: { [field]: valueInitial ?? null },
            default: true,
        })(type);
    };
}
exports.SoftDeletable = SoftDeletable;
soft_deletable_handler_subscriber_1.SoftDeletableHandlerSubscriber;
//# sourceMappingURL=soft-deletable.decorator.js.map